unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Psock, NMFtp, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    Memo1: TMemo;
    NMFTP1: TNMFTP;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    StringGrid1: TStringGrid;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    RadioGroup1: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure NMFTP1Success(Trans_Type: TCmdType);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure NMFTP1Failure(var Handled: Boolean; Trans_Type: TCmdType);
    procedure NMFTP1AuthenticationFailed(var Handled: Boolean);
    procedure NMFTP1AuthenticationNeeded(var Handled: Boolean);
    procedure NMFTP1Connect(Sender: TObject);
    procedure NMFTP1PacketSent(Sender: TObject);
    procedure NMFTP1TransactionStart(Sender: TObject);
    procedure NMFTP1TransactionStop(Sender: TObject);
    procedure NMFTP1UnSupportedFunction(Trans_Type: TCmdType);
    procedure NMFTP1Disconnect(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
//
begin
  if not(NMFTP1.Connected) then
    begin
      NMFTP1.Vendor := NMOS_AUTO;
      NMFTP1.Host := Edit1.Text;
      NMFTP1.Timeout := 30000;
      NMFTP1.UserID := Edit2.Text;
      NMFTP1.Password := Edit3.Text;
      NMFTP1.Connect;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
//
begin
  if NMFTP1.Connected then NMFTP1.Disconnect;
end;

procedure TForm1.Button3Click(Sender: TObject);
// 
begin
  ShowMessage('     ""');
  NMFTP1.Reinitialize;
end;

procedure TForm1.Button4Click(Sender: TObject);
//
var
  AnID, APass: String;
begin
  if InputQuery('', '  ', AnID) then
    if  InputQuery('', '  ', APass)   then
    begin
      NMFTP1.DoCommand('USER '+AnID);
      NMFTP1.DoCommand('PASS '+APass);
    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
// 
begin
  NMFTP1.List;
end;

procedure TForm1.Button6Click(Sender: TObject);
// 
var
  TheDir: String;
begin
  if InputQuery(' ', '  ', TheDir) then
    NMFTP1.ChangeDir(TheDir);
end;

procedure TForm1.Button7Click(Sender: TObject);
// 
var
  TheDir: String;
begin
  if InputQuery(' ', '  ',TheDir) then
    NMFTP1.MakeDirectory(TheDir);
end;

procedure TForm1.Button8Click(Sender: TObject);
// 
var
  TheDir: String;
begin
  if InputQuery(' ', '  ', TheDir) then
    NMFTP1.RemoveDir(TheDir);
end;

procedure TForm1.Button9Click(Sender: TObject);
// 
begin
  ShowMessage(NMFTP1.CurrentDir); 
end;

procedure TForm1.Button10Click(Sender: TObject);
// 
var
  OldFile,NewFile: String;
begin
  if InputQuery(' ', '  ', OldFile) then
    if InputQuery (' ', '  ', NewFile) then
         NMFTP1.Rename(OldFile, NewFile);
end;

procedure TForm1.Button11Click(Sender: TObject);
// 
var
  TheFile: String;
begin
  if InputQuery(' ', '  ', TheFile) then
      NMFTP1.Delete(TheFile);
end;

procedure TForm1.NMFTP1Success(Trans_Type: TCmdType);
var
  I: Integer;
begin
  case Trans_Type of
  cmdList:
    begin
     for I := 0 to (StringGrid1.ColCount - 1) do
         StringGrid1.Cols[I].Clear;
     StringGrid1.RowCount := NMFTP1.FTPDirectoryList.Name.Count;
     StringGrid1.ColCount := 4;
     StringGrid1.Cells[0, 0] := ' ';
     StringGrid1.Cells[1, 0] := ' ';
     StringGrid1.Cells[2, 0] := ' ';
     StringGrid1.Cells[3, 0] := '';
     for I := 0 to (NMFTP1.FTPDirectoryList.Name.Count - 1) do
        with NMFTP1.FTPDirectoryList do
        begin
          StringGrid1.Cells [0, I+1] := name[I];
          StringGrid1.Cells[1, I+1] := Size[I];
          StringGrid1.Cells[2, I+1] := ModifDate[I];
          StringGrid1.Cells [3, I+1] := Attribute[I];
        end;
     Memo1.Lines.Add('   - ');
    end;
  cmdChangeDir:
    begin
       Memo1.Lines.Add('  - ');
       NMFTP1.List;
    end;
  cmdMakeDir:
    Memo1.Lines.Add('  - ');
  cmdRemoveDir:
    Memo1.Lines.Add('  - ');
  cmdDelete:
    Memo1.Lines.Add('  - ');
  cmdRename:
    Memo1.Lines.Add('  - ');
  cmdReInit:
    Memo1.Lines.Add(' - ');
  cmdCurrentDir:
    Memo1.Lines.Add('   - ');
  end;
end;

procedure TForm1.Button12Click(Sender: TObject);
//
var
  RemoteFile,LocalFile: String;
begin
  if InputQuery(' ', ' : ', RemoteFile) then
    if OpenDialog1.Execute then
     begin
       LocalFile := OpenDialog1.FileName;
       case RadioGroup1.ItemIndex of
         0: NMFTP1.Mode(MODE_ASCII);
         1: NMFTP1.Mode(MODE_IMAGE);
         2: NMFTP1.Mode(MODE_BYTE);
       end;
       NMFTP1.Download(RemoteFile, LocalFile);
     end;
end;

procedure TForm1.Button13Click(Sender: TObject);
// ()
var
  RemoteFile, LocalFile: String;
begin
  if InputQuery('  ', ' : ',RemoteFile) then
    if OpenDialog1.Execute then
    begin
      LocalFile := OpenDialog1.FileName;
      case RadioGroup1.ItemIndex of
        0: NMFTP1.Mode(MODE_ASCII);
        1: NMFTP1.Mode(MODE_IMAGE);
        2: NMFTP1.Mode(MODE_BYTE);
      end;
      NMFTP1.DownloadRestore(RemoteFile, LocalFile);
    end;
end;

procedure TForm1.Button14Click(Sender: TObject);
//
var
  LocalFile, RemoteFile: String;
  F: File of Byte;
  FSize: Integer;
begin
  if OpenDialog1.Execute then
     if InputQuery('   ', '    ', RemoteFile) then
     begin
        LocalFile := OpenDialog1.FileName;
        case RadioGroup1.ItemIndex of
          0: NMFTP1.Mode(MODE_ASCII);
          1: NMFTP1.Mode(MODE_IMAGE);
          2: NMFTP1.Mode(MODE_BYTE);
        end;
        AssignFile(F, LocalFile);
        Reset(F);
        FSize := FileSize(F);
        CloseFile(F);
        NMFTP1.Allocate(FSize);
        NMFTP1.Upload(LocalFile, RemoteFile);
     end;
end;

procedure TForm1.Button15Click(Sender: TObject);
// ()
var
  LocalFile, RemoteFile: String;
  FPosition: Integer;
  FPos: String;
begin
  if OpenDialog1.Execute then
  if InputQuery('    ', '    ', RemoteFile) then
    if InputQuery('  ', '    : ', FPos) then
      begin
       FPosition := StrToInt(FPos);
       LocalFile := OpenDialog1.FileName;
       case RadioGroup1.ItemIndex of
         0: NMFTP1.Mode(MODE_ASCII);
         1: NMFTP1.Mode(MODE_IMAGE);
         2: NMFTP1.Mode(MODE_BYTE);
       end;
       NMFTP1.UploadRestore(LocalFile, RemoteFile, FPosition);
      end;
end;

procedure TForm1.Button16Click(Sender: TObject);
// ()
var
 LocalFile, RemoteFile: String;
begin
  if OpenDialog1.Execute then
    if InputQuery('     ', '    ', RemoteFile) then
    begin
      LocalFile := OpenDialog1.FileName;
      case RadioGroup1.ItemIndex of
        0: NMFTP1.Mode(MODE_ASCII);
        1: NMFTP1.Mode(MODE_IMAGE);
        2: NMFTP1.Mode (MODE_BYTE);
      end;
      NMFTP1.UploadAppend(LocalFile, RemoteFile);
    end;
end;

procedure TForm1.Button17Click(Sender: TObject);
// ( )
var
  LocalFile: String;
begin
  if OpenDialog1.Execute then
  begin
   LocalFile := OpenDialog1.FileName;
   case RadioGroup1.ItemIndex of
     0: NMFTP1.Mode(MODE_ASCII);
     1: NMFTP1.Mode(MODE_IMAGE);
     2: NMFTP1.Mode (MODE_BYTE);
   end;
   NMFTP1.UploadUnique(LocalFile);
  end;
end;

procedure TForm1.NMFTP1Failure(var Handled: Boolean; Trans_Type: TCmdType);
begin
case Trans_Type of
  cmdChangeDir: Memo1.Lines.Add('  ');
  cmdMakeDir: Memo1.Lines.Add('  ');
  cmdDelete: Memo1.Lines.Add('  ');
  cmdRemoveDir: Memo1.Lines.Add('  ');
  cmdList: Memo1.Lines.Add('  ');
  cmdRename: Memo1.Lines.Add('  ');
  cmdUpRestore: Memo1.Lines.Add('  UploadRestore');
  cmdDownRestore: Memo1.Lines.Add('  DownloadRestore');
  cmdDownload: Memo1.Lines.Add('  Download');
  cmdUpload: Memo1.Lines.Add('  Upload');
  cmdAppend: Memo1.Lines.Add('  UploadAppend');
  cmdReInit: Memo1.Lines.Add('  Reinitialize');
  cmdAllocate: Memo1.Lines.Add('  Allocate');
  cmdNList: Memo1.Lines.Add('  NList');
  cmdDoCommand: Memo1.Lines.Add('  DoCommand');
  cmdCurrentDir: Memo1.Lines.Add('  CurrentDir');
end;

end;

procedure TForm1.NMFTP1AuthenticationFailed(var Handled: Boolean);
var
  ThePass, TheID: String;
begin
 if MessageDlg(' .  ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
 begin
   ThePass := NMFTP1.Password;
   TheID := NMFTP1.UserID;
   InputQuery (' ', '  ', TheID);
   InputQuery (' ', ' ', ThePass);
   NMFTP1. Password := ThePass;
   NMFTP1.UserID := TheID;
   Handled := true;
 end;
end;

procedure TForm1.NMFTP1AuthenticationNeeded(var Handled: Boolean);
var
  APass,AnID: String;
begin
  if NMFTP1.Password = '' then
  begin
   if InputQuery(' ', ' : ', APass) then
   begin
     NMFTP1.Password := APass;
     Handled := true;
   end
   else
     Handled := false;
  end;
  if NMFTP1.UserID ='' then
  begin
   if InputQuery('  ', '  : ', AnID) then
   begin
      NMFTP1.UserID := AnID;
      Handled := true;
   end
   else
      Handled := false;
  end;
end;

procedure TForm1.NMFTP1Connect(Sender: TObject);
begin
  Memo1.Lines.Add('...');
end;

procedure TForm1.NMFTP1PacketSent(Sender: TObject);
begin
  StatusBar1.SimpleText := ' '+IntToStr(NMFTP1.BytesSent)+
   '   '+IntToStr (NMFTP1.BytesTotal);
end;

procedure TForm1.NMFTP1TransactionStart(Sender: TObject);
begin
  Memo1.Lines.Add('  .');
end;

procedure TForm1.NMFTP1TransactionStop(Sender: TObject);
begin
  Memo1.Lines.Add('  .');
end;

procedure TForm1.NMFTP1UnSupportedFunction(Trans_Type: TCmdType);
begin
  case Trans_Type of
      cmdChangeDir: Memo1.Lines.Add(' ChangeDir    ');
      cmdMakeDir: Memo1.Lines.Add(' MakeDir    ');
      cmdDelete: Memo1.Lines.Add(' Delete    ');
      cmdRemoveDir: Memo1.Lines.Add(' RemoveDir    ');
      cmdList: Memo1.Lines.Add(' List    ');
      cmdRename: Memo1.Lines.Add(' Rename    ');
      cmdUpRestore: Memo1.Lines.Add(' UploadRestore    ');
      cmdDownRestore: Memo1.Lines.Add(' DownloadRestore    ');
      cmdDownload: Memo1.Lines.Add(' Download    ');
      cmdUpload: Memo1.Lines.Add(' Upload    ');
      cmdAppend: Memo1.Lines.Add(' UploadAppend    ');
      cmdReInit: Memo1.Lines.Add(' Reinitialize    ');
      cmdAllocate: Memo1.Lines.Add(' Allocate    ');
      cmdNList: Memo1.Lines.Add(' NList    ');
      cmdDoCommand: Memo1.Lines.Add(' DoCommand    ');
      cmdCurrentDir: Memo1.Lines.Add(' CurrentDir    ');
  end;
end;

procedure TForm1.NMFTP1Disconnect(Sender: TObject);
begin
   Memo1.Lines.Add(' ...');
end;

end.
